<?php
// $Id: multiple_email_handler_filter_current.inc,v 1.1.2.2 2010/09/13 01:08:38 shawndearmond Exp $

/**
 * @file
 * filter heandler for matching email addresses to cck email field.
 */

/**
 * Filter handler for the current user's email addresses to match to a cck field
 */
class multiple_email_handler_filter_current extends views_handler_filter_boolean_operator {
  function construct() {
    parent::construct();
    $this->value_value = t('Matches one of the multiple email addresses of the logged in user');
  }

  function query() {
    $this->ensure_my_table();
    $where = "$this->table_alias.$this->real_field ";
    // get the current user's addresses
    global $user;
    $emails = multiple_email_load_addresses($user->uid);
    $addresses = array();
    foreach ($emails as $email) {
      if (is_object($email) && $email->confirm_code) {
        $addresses[] = $email->email;
      }
    }
    if (empty($this->value)) {
      $where .= 'NOT ';
    }
    $where .= "IN ('". implode("','", $addresses) ."') ";
    $this->query->add_where($this->options['group'], $where);
  }
}